#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=rc.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Timers.au3>

$Form1_1 = GUICreate("River Crocodile - 1.0", 290, 338, 2557, 524)
GUISetIcon(@ScriptDir &"\rc.ico", -1)
$Group1 = GUICtrlCreateGroup("Modus", 8, 8, 273, 185)
$Radio5 = GUICtrlCreateRadio("Zeitgesteuert", 16, 32, 113, 17)
GUICtrlSetState(-1, $GUI_CHECKED)
$Radio6 = GUICtrlCreateRadio("Sanduhr", 136, 32, 113, 17)
$Label1 = GUICtrlCreateLabel("Aktuelle Zeit:", 16, 56, 66, 17)
$Label2 = GUICtrlCreateLabel("00:00", 16, 72, 61, 28)
GUICtrlSetFont(-1, 14, 400, 0, "MS Reference Sans Serif")
$Input1 = GUICtrlCreateInput("00", 18, 128, 33, 32)
GUICtrlSetStyle(-1, 0x2000)
GUICtrlSetLimit(-1, 2)
GUICtrlSetFont(-1, 14, 400, 0, "MS Reference Sans Serif")
$Label3 = GUICtrlCreateLabel(":", 56, 128, 13, 28)
GUICtrlSetFont(-1, 14, 400, 0, "MS Reference Sans Serif")
$Input2 = GUICtrlCreateInput("00", 74, 128, 33, 32)
GUICtrlSetStyle(-1, 0x2000)
GUICtrlSetLimit(-1, 2)
GUICtrlSetFont(-1, 14, 400, 0, "MS Reference Sans Serif")
$Label4 = GUICtrlCreateLabel("Startzeit:", 16, 104, 45, 17)
$Label5 = GUICtrlCreateLabel("Min", 200, 56, 38, 28)
GUICtrlSetFont(-1, 14, 400, 0, "MS Reference Sans Serif")
$Input3 = GUICtrlCreateInput("00", 136, 56, 57, 32)
GUICtrlSetStyle(-1, 0x2000)
GUICtrlSetLimit(-1, 3)
GUICtrlSetFont(-1, 14, 400, 0, "MS Reference Sans Serif")
$Radio7 = GUICtrlCreateRadio("Inaktivitt (Experimentell)", 136, 96, 137, 17)
$Label6 = GUICtrlCreateLabel("Fhrt die gewhlte Aktion nach 30 min ohne Benutzeraktivitt herunter. Diese Funktion befindet sich noch in der Testphase!", 136, 120, 137, 65)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group2 = GUICtrlCreateGroup("Optionen", 8, 200, 273, 129)
$Radio1 = GUICtrlCreateRadio("Herunterfahren", 16, 224, 97, 17)
GUICtrlSetState(-1, $GUI_CHECKED)
$Radio2 = GUICtrlCreateRadio("Neu Starten", 16, 248, 105, 17)
$Radio3 = GUICtrlCreateRadio("Abmelden", 16, 272, 97, 17)
$Radio4 = GUICtrlCreateRadio("Ruhezustand", 16, 296, 105, 17)
$Checkbox1 = GUICtrlCreateCheckbox("Erzwingen", 120, 224, 113, 17)
$Button1 = GUICtrlCreateButton("Timer starten", 120, 248, 153, 65)
GUICtrlSetFont(-1, 15, 400, 0, "MS Reference Sans Serif")
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUISetState(@SW_SHOW)
$LastDiff = 77
$Timer = TimerInit()
While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $Button1
			$TGet = TypeGet()
			$OGet = OptionGet()
			TimerStart($TGet, $OGet)
		Case $Radio7
			$result = MsgBox(266289,"Experimentelle Funktion","Warnung: Diese Funktion befindet sich noch in der Entwicklung und ist nur experimentell verfgbar. Benutzen Sie diese Funktion mit usserster Vorsicht, fr allfllige verlorene Daten bernehme ich keine Haftung!",0)
			If $result = 2 Then
				GUICtrlSetState($Radio7, $GUI_UNCHECKED)
				GUICtrlSetState($Radio5, $GUI_CHECKED)
			EndIf
		Case $GUI_EVENT_CLOSE
			Exit
	EndSwitch
	$TimerDiff = @MIN
	If $TimerDiff <> $LastDiff Then
		GUICtrlSetData($Label2, @HOUR &":" &@MIN)
		$LastDiff = $TimerDiff
	EndIf
	$Diff = StringSplit(TimerDiff($Timer), ".")
	$DefDif = $Diff[1]
	If $DefDif > 5000 Then
		InputCheck()
		$Timer = TimerInit()
	EndIf
WEnd

Func TypeGet()
	If GUIctrlRead($Radio1) = 1 Then
		$Return = 1
	Else
		If GUIctrlRead($Radio2) = 1 Then
			$Return = 2
		Else
			If GUIctrlRead($Radio3) = 1 Then
				$Return = 0
			Else
				If GUIctrlRead($Radio4) = 1 Then
					$Return = 32
				EndIf
			EndIf
		EndIf
	EndIf
	If GUIctrlRead($Checkbox1) = 1 Then
		$Return = $Return + 4
	EndIf
	Return $Return
EndFunc

Func OptionGet()
	If GUIctrlRead($Radio5) = 1 Then
		$Return = 1
	Else
		If GUIctrlRead($Radio6) = 1 Then
			$Return = 2
		Else
			If GUIctrlRead($Radio7) = 1 Then
				$Return = 3
			EndIf
		EndIf
	EndIf
	Return $Return
EndFunc

Func TimerStart($Type, $Option)
	$Hour = GUICtrlRead($Input1)
	$Min = GUICtrlRead($Input2)
	$Minutes = GUICtrlRead($Input3)
	If $Option = 1 Then
		GUIDelete($Form1_1)
		TrayTip('Timer gesetzt!', 'Der Timer wurde gesetzt. Die gewhlte Option wird um ' &$Hour &':' &$Min &' ausgefhrt. Diese Meldung ist einmalig. Falls Sie den Timer abbrechen wollen, klicken Sie mit der rechten Maustaste auf dieses Symbol und whlen Sie "Exit".', 10, 1)
		While True
			If $Min = @MIN Then
				If $Hour = @HOUR Then
					Shutdown($Type)
				EndIf
			Else
				Sleep(60000)
			EndIf
		WEnd
	ElseIf $Option = 2 Then
		GUIDelete($Form1_1)
		$Milliseconds = $Minutes * 60000
		$TimerInit = TimerInit()
		$WarningCount = $Milliseconds / 600000
		$WarningCountFull = StringSplit($WarningCount, ".")
		$WarningCount = $WarningCountFull[1]
		TrayTip('Timer gesetzt!', 'Der Timer wurde gesetzt. Die gewhlte Option wird in ' &$Minutes &' Minuten ausgefhrt. Falls Sie den Timer abbrechen wollen, klicken Sie mit der rechten Maustaste auf dieses Symbol und whlen Sie "Exit".', 10, 1)
		For $i = 1 to $WarningCount Step 1
			Sleep(600000)
			$TimerDif = TimerDiff($TimerInit)
			$Remaining = $Milliseconds - $TimerDif
			TrayTip('Information!', 'Der gesetzte Timer endet in ' &$Remaining &' Minuten. Um den Vorgang abzubrechen, klicken Sie mit der Rechten Maustaste auf dieses Symbol und whlen Sie "Exit"!ss', 10, 1)
		Next
		Shutdown($Type)
	Else
		GUIDelete($Form1_1)
		TrayTip('berwachung gestartet!', 'Das Programm berwacht nun Ihre Aktivitt (nicht WAS Sie tun, nur OB Sie was tun ;) ). Um den Vorgang abzubrechen, klicken Sie mit der Rechten Maustaste auf dieses Symbol und whlen Sie "Exit"!ss', 10, 1)
		While True
			$Idle = _Timer_GetIdleTime()
			If $Idle >= 1800000 Then
				Shutdown($Type)
			EndIf
			Sleep(600000)
		WEnd
	EndIf
EndFunc

Func InputCheck()
	If GUICtrlRead($Input1) > 23 Then
		GUICtrlSetData($Input1, 23)
	EndIf
	If GUICtrlRead($Input2) > 59 Then
		GUICtrlSetData($Input2, 59)
	EndIf
EndFunc